#include <stdio.h>
#include <stdlib.h>

/* jedno pole rybnika */
typedef struct {
	int temp;	/* pocatecni teplota */
	int time;	/* cas nedcasnejsiho pripluti */
	int heappos;	/* pozice v halde */
	int z;		/* odkud sem Julka priplula */
	int doba;	/* a jak dlouho tam cekala*/
} pole;

/* zadane parametry */
int m,n,t1,t2,x1,y1,x2,y2; 
 
/* rybnik po radcich (indexovany od nuly!)*/
pole *rybnik;
#define R(x,y) (rybnik[(x)+m*(y)])

/* halda v poli, indexuje primo do pole rybnik[] */
int *halda; 
int velhaldy;

void nacti(FILE *f)
{
	int i,j;
	fscanf(f,"%d %d %d %d",&m,&n,&t1,&t2);
	fscanf(f,"%d %d %d %d",&x1,&y1,&x2,&y2);
	/* prevod na cislovani od 0 */
	x1--;y1--;x2--;y2--;
	rybnik=(pole *)malloc(sizeof(pole)*m*n);
	for(j=0;j<n;j++)
		for(i=0;i<m;i++)
		{
			fscanf(f,"%d",&(R(i,j).temp));
			R(i,j).heappos=-1;
			R(i,j).time=3628800;
		}
	R(x1,y1).time=0;
	R(x1,y1).heappos=0;
	R(x1,y1).z=-1;
	halda=(int *)malloc(sizeof(int)*m*n);
	velhaldy=1;
	halda[0]=x1+y1*m;
}

/*bublej danou polozku haldou do spravne pozice*/
void prehodhaldu(int h1,int h2)
{
	int r1=halda[h1];
	int r2=halda[h2];
	rybnik[r1].heappos=h2;
	rybnik[r2].heappos=h1;
	halda[h1]=r2;
	halda[h2]=r1;
}
void bublejnahoru(int h)
{
	while((h>0)&&(rybnik[halda[h]].time<rybnik[halda[(h-1)/2]].time))
	{
		prehodhaldu(h,(h-1)/2);
		h=(h-1)/2;
	}		
}
void bublejdolu(int h)
{
	while(h*2+1<velhaldy)
	{
		int h2=h;
		if(h*2+2==velhaldy)
		{
			if(rybnik[halda[h]].time>rybnik[halda[(h*2)+1]].time)
				prehodhaldu(h,h*2+1);
			return;
		}
		if (rybnik[halda[h2]].time>rybnik[halda[h*2+1]].time) h2=h*2+1;
		if (rybnik[halda[h2]].time>rybnik[halda[h*2+2]].time) h2=h*2+2;
		if (h==h2) return;
		prehodhaldu(h,h2);
		h=h2;
	}		
}

/*update haldy--prijezd nejdrive v case time, nejpozdeji v time+maxcekani*/
void updatepole(int x,int y,int time,int maxcekani,int z)
{
	int cekani=0;
	if((x!=x2)||(y!=y2))
	{
		if((R(x,y).temp+time>t2)) return; /*moc horke*/
		if((R(x,y).temp+time+maxcekani<t1)) return; /*moc studene*/
		if(R(x,y).temp+time<t1) cekani=t1-(R(x,y).temp+time);
	}
//	printf("updatepole(%d,%d,%d,%d)\n",x,y,time,maxcekani);
	if(R(x,y).time>time+cekani+1)
	{
		R(x,y).time=time+cekani+1;
		R(x,y).z=z;
		R(x,y).doba=cekani;
		if(R(x,y).heappos<0)
		{
			R(x,y).heappos=velhaldy;
			halda[velhaldy]=x+m*y;
			velhaldy++;
		}
		bublejnahoru(R(x,y).heappos);		
	}
}

void vypis(FILE *f)
{
	char* pokyny;
	pokyny=malloc(sizeof(char)*10*(m*n+1000));
	int x=x2;
	int y=y2;
	int pokynu=0;
	while(R(x,y).z>=0)
	{
//		printf("%d %d\n",x,y);
		int nx=R(x,y).z%m;
		int ny=R(x,y).z/m;
		if(nx==x+1) sprintf(pokyny+10*pokynu,"Z ");
		if(nx==x-1) sprintf(pokyny+10*pokynu,"V ");
		if(ny==y-1) sprintf(pokyny+10*pokynu,"J ");
		if(ny==y+1) sprintf(pokyny+10*pokynu,"S ");
		pokynu++;
		if(R(x,y).doba>0) 
		{	
			sprintf(pokyny+10*pokynu,"%d ",R(x,y).doba);
			pokynu++;
		}
		x=nx;
		y=ny;
	}
	for(;pokynu>0;pokynu--)
		fputs(pokyny+10*pokynu-10,f);
	fputs("\n",f);
}
int main()
{
	FILE *f1=fopen("rybka.in","rt");
	FILE *f2=fopen("rybka.out","wt");
	nacti(f1);
	while((velhaldy>0)&&((R(x2,y2).time>=3628800)||(R(x2,y2).heappos>=0)))
	{
		/*vyber z haldy*/
		int h=halda[0];
		int x=h%m;
		int y=h/m;
		/*cas, kdy ma uz Julka moznost z pole odjet*/
		int time=rybnik[h].time;
		/*teplota pole, kdyz ma julka moznost odjet*/
		int temp=time+rybnik[h].temp;
		int maxcekani=t2-temp;
//		printf("heap->(%d,%d) %ds %dt\n",x,y,time,temp);
		rybnik[h].heappos=-1;
		halda[0]=halda[velhaldy-1];
		velhaldy--;
		bublejdolu(0);
		/*vloz do haldy sousedy*/
		if(temp>t2) continue;
		if(x>0) updatepole(x-1,y,time,maxcekani,h); 
		if(y>0) updatepole(x,y-1,time,maxcekani,h); 
		if(x+1<m) updatepole(x+1,y,time,maxcekani,h); 
		if(y+1<n) updatepole(x,y+1,time,maxcekani,h); 
	}
	if(R(x2,y2).time<3628800)
		vypis(f2);	
	else
		fprintf(f2,"Chudak Julka!\n");
	return 0;
}
